/*
  otak project.
  copyright (C) 2002, 2003, 2004 
  grzegorz moskal,  <eldevarth@nemerle.org>
  license : gnu gpl version 2 			*/

#define OTAKCONFIG_C_
#include "otakconfig.h"

// messages
static int no_messages = 1;
int silent = 0;
int silent_attr = -1;
// a few normal varibles 
int first_time = 0;
int sort_database, write_database = 1, read_wins;
// command line arg.
int confirm_adding = 0;
char *query_arg;
int query_each_database = 0;
char *new_email_arg;
char *program_name = NULL;
// files names
char *config_name, *base_name, *baseconfig_name, *basedir_name, *size_name;
// shortcuts
char *del_key, *add_key, *edit_key, *back_key, *quit_key = "q" , *move_key, *load_key;
// stanza varibles
char *enter_cmd, *menu_title, *query_show;
// ascii art
int show_intro, toolbar_up, big_windows, hide_wininfo, show_labels;
char  *arrow_str,  *space_str;
#define DEFAULT_ARROW ":: "

void set_otakconf(struct ecl_file *file)
{
	struct ecl_stanza *s = ecl_file_find_stanza(file, NULL);

	ecl_stanza_bool(s, "silent", &silent, 0);
	ecl_stanza_bool(s, "no.messages", &no_messages, 1);
	// normal ::	
	ecl_stanza_bool(s, "sort.base", &sort_database, 1);
	ecl_stanza_bool(s, "read.size.file", &read_wins, 1);
	// files ::
	ecl_stanza_string(s, "base.config.file", &baseconfig_name, "");
	ecl_stanza_string(s, "base.dir", &basedir_name, "");
	ecl_stanza_string(s, "size.file", &size_name, "");
	// shortcuts ::
	ecl_stanza_string(s, "remove.key", &del_key, "d");
	ecl_stanza_string(s, "add.key", &add_key, "a");
	ecl_stanza_string(s, "edit.key", &edit_key, "e");
	ecl_stanza_string(s, "back.key", &back_key, "q");
	ecl_stanza_string(s, "move.key", &move_key, "m");
	ecl_stanza_string(s, "load.key", &load_key, "l");
	// stanza varibles ::
	ecl_stanza_string(s, "cmd.on.enter", &enter_cmd, "email");
	ecl_stanza_string(s, "menu.title", &menu_title, "name");

	if (query_show == NULL)
		ecl_stanza_string(s, "show.query", &query_show, "email");
	// ascii art ::
	ecl_stanza_bool(s, "show.intro", &show_intro, 0);
	ecl_stanza_bool(s, "toolbar.up", &toolbar_up, 1);
	ecl_stanza_bool(s, "big.windows", &big_windows, 0);
	ecl_stanza_bool(s, "hide.wininfo", &hide_wininfo, 0);
	ecl_stanza_bool(s, "show.labels", &show_labels, 0);
	ecl_stanza_string(s, "arrow.string", &arrow_str, DEFAULT_ARROW);
}

static void check_otakconf(void)
{
	char *jmp;

	if (strcmp(arrow_str, DEFAULT_ARROW))
		arrow_str = strglue(arrow_str, " ", "");

	jmp = space_str = strdup(arrow_str);

	for (; *jmp; jmp++)
		*jmp = ' ';
		
	if (silent_attr >= 0 && silent != silent_attr) {
		silent = silent_attr;
		return;
	}

	if (no_messages)
		silent = MESSAGES;
	else if (silent)
		silent = MESSAGES_AND_ERRORS;
}

int read_otakconf(char *name)
{
	struct ecl_file *file = ecl_file_open(name);

	if (file == NULL)
		return 0;	

	ecl_file_init(file);
	set_otakconf(file);
	check_otakconf();	
	ecl_file_close(file);
	
	msgf("read in config file:       '%s'", name);
	
	return 1;
}

