/*
  otak project.
  copyright (C) 2002, 2003, 2004 
  grzegorz moskal,  <eldevarth@nemerle.org>
  license : gnu gpl version 2 			*/

#define SIZES_C_
#include "sizes.h"
struct size sizes[Wtext+1];

static int all_sizes;
static int vx, vy, vw, vh;

// regexp rulez ! ;^)

void set_size(int win, struct tobj *twin)
{
	long n;
	
	tget(twin, TOBJ_LEFT, &n);
	set_x(win, (int)n);
	
	tget(twin, TOBJ_TOP, &n);
	set_y(win, (int)n);
	
	tget(twin, TOBJ_WIDTH, &n);
	set_w(win, (int)n);

	tget(twin, TOBJ_HEIGHT, &n);
	set_h(win, (int)n);
}

static void change_size(char *s)
{
	int i;
	if (((i = return_windex(s)) > -1) && all_sizes) {
		struct size *j = &sizes[i];
		struct size tmp = { j->x, j->y, j->w, j->h };
		
		if ((!set_x(i,(int)vx) || !set_y(i,(int)vy) || 
 				!set_w(i,(int)vw) || !set_h(i, (int)vh))) {
			j->x = tmp.x;
			j->y = tmp.y;
			j->w = tmp.w;
			j->h = tmp.h;
		}
	} else if (i == -2) 
		if ((t_screen_width == (unsigned int)vw || 
			t_screen_height == (unsigned int)vh) && (vx == big_windows))
			all_sizes = 1;

	vx = vy = vw = vh = -1;
}

static void set_varibles(struct ecl_stanza *s)
{
	ecl_stanza_int(s, "x", &vx, 0);
	ecl_stanza_int(s, "y", &vy, 0);
	ecl_stanza_int(s, "w", &vw, 0);
	ecl_stanza_int(s, "h", &vh, 0);
}

int read_sizes(char *name) 
{
	struct ecl_file	*file;
	struct ecl_stanza *stanza;

	if (read_wins == 0)
		return 1;

	if (name == NULL)
		return 0;		
	
	if ((file = ecl_file_open(name)) == NULL)
		return 0;

	ecl_file_init(file);

	for (stanza = file->head; stanza; SWITCH(stanza)) {
		set_varibles(stanza);
		change_size(stanza->name);
	}
	ecl_file_close(file);

	return 1;
}

void write_sizes(char *name)
{
	FILE *fd;
	int i = 0;
	
	if (read_wins == 0)
		return;	// why should otak write sizes ? if otak didn`t read it

	if (!(fd = fopen(name, "w+"))) {
		errmsgf("Cannot write window-sizes to file - '%s'", name);
		return;
	}  
	
	fprintf(fd,"[%s]\n", "screen");
	fprintf(fd,"w=%d\n", t_screen_width);
	fprintf(fd,"h=%d\n\n", t_screen_height);
	fprintf(fd,"x=%d\n\n", big_windows);
	

	for (; i <= Wtext; i++) {
		fprintf(fd,"[%s]\n", return_wname(i));
		fprintf(fd,"x=%d\n", get_x(i));
		fprintf(fd,"y=%d\n", get_y(i));
		fprintf(fd,"w=%d\n", get_w(i));
		fprintf(fd,"h=%d\n\n", get_h(i));
	}
	msgf("wrote down sizes to file:  '%s'", name);
	fclose(fd);
}

int get_x(int win)
{
	return sizes[win].x;
}

int get_y(int win)
{
	return sizes[win].y;
}

int get_w(int win)
{
	return sizes[win].w;
}

int get_h(int win)
{
	return sizes[win].h;
}

int set_x(int win, int x)
{
	if (x >= 0 && (unsigned int)x <= t_screen_width) {
		sizes[win].x = x;
		return 1;
	}
	return 0;
}

int set_y(int win, int y)
{
	if (y >= 0 && (unsigned int)y <= t_screen_height) {
		sizes[win].y = y;
		return 1;
	}
	return 0;
}

int set_w(int win, int w)
{
	if (w > 0 && (unsigned int)(w + sizes[win].x) <= t_screen_width) {
		sizes[win].w = w;
		return 1;
	}
	return 0;
}

int set_h(int win, int h)
{
	if (h > 0 && (unsigned int)(h + sizes[win].y) <= t_screen_height) {
		sizes[win].h = h;
		return 1;
	}
	return 0;
}

static void fill_sizes(int t[])
{
	int i = 0;
	for (; i <= Wtext; i++) {
		sizes[i].x = t[(i*4)];
		sizes[i].y = t[(i*4)+1];
		sizes[i].w = t[(i*4)+2];
		sizes[i].h = t[(i*4)+3];
	}
}

void init_sizes(void)
{
	DEFINE_NORMAL(normal);
	DEFINE_BIG(big);

	fill_sizes((big_windows) ? big : normal);
}

char *window_names[] = {
	"window-choice", "window-data", "window-edit",
	"window-help", "window-info", "window-load", 
	"window-people", "window-search", "window-text"
};

static char *return_wname(int w)
{
	if (w >= Wchoice && w <= Wtext)
		return window_names[w];
	return 0;
}

static int return_windex(char *pattern)
{
	int w;
	for (w = Wchoice; w <= Wtext; w++)
		if (strcmp(window_names[w], pattern) == 0)
			return w;
			
	if (strcmp("screen", pattern) == 0)
		return -2;
		
	return -1;
}
