#ifndef _TINPUT_H
#define _TINPUT_H

#include "tobj.h"


/* Events (1301 - 1400) */
#define EVENT_TINPUT_ACCEPT  (1301L)
#define EVENT_TINPUT_REJECT  (1302L)
#define EVENT_TINPUT_CHANGED (1303L)

/* Methods (301-400) */
#define  TINPUT_CURSOR_LEFT  (301L)
#define  TINPUT_CURSOR_RIGHT (302L)
#define  TINPUT_CURSOR_BEGIN (303L)
#define  TINPUT_CURSOR_END   (304L)
#define  TINPUT_PUT_CHAR     (305L)

#define  TINPUT_INPUTMODE_SWITCH (310L)

/* Attributes (301-400) */
#define TINPUT_BUFFER_CURRENT 	(301L)
#define TINPUT_BUFFER_MAXLEN	(302L)
#define TINPUT_BUFFER_POS	(303L)
#define TINPUT_HISTORY		(310L)
#define TINPUT_HISTORY_MAXLEN	(311L)
#define TINPUT_HISTORY_COUNT	(312L)
#define TINPUT_CURSOR_POS	(321L)
#define TINPUT_INPUTMODE	(323L)
#define TINPUT_ACCEPT_CHARS	(324L)
#define TINPUT_REJECT_CHARS	(325L)

/* values of TINPUT_INPUTMODE */
#define TINPUT_INPUTMODE_INSERT		(0L)
#define TINPUT_INPUTMODE_REPLACE 	(1L)


struct tobj *tinput_init(struct tobj *parent, unsigned int x,
			 unsigned int y, unsigned int len, char *deftext,
			 unsigned int maxlen);

#endif
