/*
  otak project.
  copyright (C) 2002, 2003, 2004 
  grzegorz moskal,  <eldevarth@nemerle.org>
  license : gnu gpl version 2 			*/

#define WDATA_C_
#include "wdata.h"

static struct tobj *win_data, *cmenu_data;
extern int edit_mode;

int wdata_service(struct tevent *e)
{
	if (e->sender != cmenu_data && e->sender != win_data && e->sender)
		return 0;
		
	switch (e->data) {
	case K_ESC:
	case K_LEFT:
		change_screen_b(0, 0);
		break;
	case EVENT_TLIST_CHANGE:
		if (!edit_mode)
			scrdata_refresh();
		return 1;
	case EVENT_TLIST_REJECT: 
	case EVENT_TMENU_REJECT:
		change_screen_b(0, 0);
		return 1;
	}
	return 0;

}

int wdata_create(struct tobj *rootwin)
{
	DEFINE_SIZES(Wdata);
	struct stanza *js;
	
	if (!(win_data = twin_init(rootwin, x, y, w, h, translate("Data"))))
		return 0;
	if (!(cmenu_data = tcmenu_init(win_data, 1, 1, w-2, h-2, mtab)))
		return 0;
	for (js = first_stanza; js; js = js->next) 
		if (!add_menuobj(cmenu_data, js->label, &windata_service_m, 0))
			return 0;
        tset(win_data, TOBJ_HIDDEN, 1);
	
	return 1;
}
void wdata_free(void)
{
	set_size(Wdata, win_data);
	tobj_free(win_data);
	win_data = NULL;
	cmenu_data = NULL;
}

void wdata_show()
{
	tobj_show(win_data);
}

void wdata_hide()
{
	tobj_rhide(win_data);
}

void wdata_set(long m, long data)
{
	tset(win_data, m, data);
}

void mdata_get(long d, long *a)
{
	tget(cmenu_data, d, a);
}

void mdata_domethod(long m, long d)
{
	tobj_domethod(cmenu_data, m, d);
}

