/*
  otak project.
  copyright (C) 2002, 2003, 2004 
  grzegorz moskal,  <eldevarth@nemerle.org>
  license : gnu gpl version 2 			*/

#define WINFO_C_
#include "winfo.h"

struct tobj *win_info, *box_info;

void winfo_show()
{
	if (hide_wininfo)
		return;
	tobj_show(win_info);
}

void winfo_hide()
{
	tobj_rhide(win_info);
}

int winfo_create(struct tobj *rootwin, char *s)
{
	DEFINE_SIZES(Winfo);
	if (!(win_info = twin_init(rootwin, 
		x, y, w, h, translate("Info window"))))
		return 0;
	if (!winfo_fill(strdup(" ")))
		return 0;
	
	tset(win_info, TOBJ_HIDDEN, hide_wininfo);
	xfree(s);
	return 1;
}

void winfo_free()
{
	set_size(Winfo, win_info);
	tobj_free(win_info);
	win_info = box_info = NULL;
}

int winfo_fill(char *s)
{
	int reinit = (box_info) ? 1 : 0;
	if (reinit)
		tobj_free(box_info);
	if (!(box_info = ttxtview_init(win_info, 1, 1,
		get_w(Winfo)-2, get_h(Winfo)-2, s))) {
		if (reinit)
			errexit("Cannot reinit box info\n");
		return 0;
	}
	xfree(s);
	return 1;
}

void winfo_get(long attr, long *data)
{
	tget(win_info, attr, data);
}

